Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -2627,4 +5294,5 @@
         public const int dfusestrongsplits = 1;
         public const int dfuseevs = 2;
+        public const int dffirstversion = 0;
 
 
@@ -2683,4 +5351,70 @@
             samplesize = Math.Max((int)Math.Round(r*npoints), 1);
             dfbuildinternal(xy, npoints, nvars, nclasses, ntrees, samplesize, Math.Max(nvars/2, 1), dfusestrongsplits+dfuseevs, ref info, df, rep);
+        }
+
+
+        /*************************************************************************
+        This subroutine builds random decision forest.
+        This function gives ability to tune number of variables used when choosing
+        best split.
+
+        INPUT PARAMETERS:
+            XY          -   training set
+            NPoints     -   training set size, NPoints>=1
+            NVars       -   number of independent variables, NVars>=1
+            NClasses    -   task type:
+                            * NClasses=1 - regression task with one
+                                           dependent variable
+                            * NClasses>1 - classification task with
+                                           NClasses classes.
+            NTrees      -   number of trees in a forest, NTrees>=1.
+                            recommended values: 50-100.
+            NRndVars    -   number of variables used when choosing best split
+            R           -   percent of a training set used to build
+                            individual trees. 0<R<=1.
+                            recommended values: 0.1 <= R <= 0.66.
+
+        OUTPUT PARAMETERS:
+            Info        -   return code:
+                            * -2, if there is a point with class number
+                                  outside of [0..NClasses-1].
+                            * -1, if incorrect parameters was passed
+                                  (NPoints<1, NVars<1, NClasses<1, NTrees<1, R<=0
+                                  or R>1).
+                            *  1, if task has been solved
+            DF          -   model built
+            Rep         -   training report, contains error on a training set
+                            and out-of-bag estimates of generalization error.
+
+          -- ALGLIB --
+             Copyright 19.02.2009 by Bochkanov Sergey
+        *************************************************************************/
+        public static void dfbuildrandomdecisionforestx1(double[,] xy,
+            int npoints,
+            int nvars,
+            int nclasses,
+            int ntrees,
+            int nrndvars,
+            double r,
+            ref int info,
+            decisionforest df,
+            dfreport rep)
+        {
+            int samplesize = 0;
+
+            info = 0;
+
+            if( (double)(r)<=(double)(0) | (double)(r)>(double)(1) )
+            {
+                info = -1;
+                return;
+            }
+            if( nrndvars<=0 | nrndvars>nvars )
+            {
+                info = -1;
+                return;
+            }
+            samplesize = Math.Max((int)Math.Round(r*npoints), 1);
+            dfbuildinternal(xy, npoints, nvars, nclasses, ntrees, samplesize, nrndvars, dfusestrongsplits+dfuseevs, ref info, df, rep);
         }
 
@@ -3490,4 +6224,74 @@
 
         /*************************************************************************
+        Serializer: allocation
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void dfalloc(alglib.serializer s,
+            decisionforest forest)
+        {
+            s.alloc_entry();
+            s.alloc_entry();
+            s.alloc_entry();
+            s.alloc_entry();
+            s.alloc_entry();
+            s.alloc_entry();
+            apserv.allocrealarray(s, forest.trees, forest.bufsize);
+        }
+
+
+        /*************************************************************************
+        Serializer: serialization
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void dfserialize(alglib.serializer s,
+            decisionforest forest)
+        {
+            s.serialize_int(scodes.getrdfserializationcode());
+            s.serialize_int(dffirstversion);
+            s.serialize_int(forest.nvars);
+            s.serialize_int(forest.nclasses);
+            s.serialize_int(forest.ntrees);
+            s.serialize_int(forest.bufsize);
+            apserv.serializerealarray(s, forest.trees, forest.bufsize);
+        }
+
+
+        /*************************************************************************
+        Serializer: unserialization
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void dfunserialize(alglib.serializer s,
+            decisionforest forest)
+        {
+            int i0 = 0;
+            int i1 = 0;
+
+            
+            //
+            // check correctness of header
+            //
+            i0 = s.unserialize_int();
+            ap.assert(i0==scodes.getrdfserializationcode(), "DFUnserialize: stream header corrupted");
+            i1 = s.unserialize_int();
+            ap.assert(i1==dffirstversion, "DFUnserialize: stream header corrupted");
+            
+            //
+            // Unserialize data
+            //
+            forest.nvars = s.unserialize_int();
+            forest.nclasses = s.unserialize_int();
+            forest.ntrees = s.unserialize_int();
+            forest.bufsize = s.unserialize_int();
+            apserv.unserializerealarray(s, ref forest.trees);
+        }
+
+
+        /*************************************************************************
         Classification error
         *************************************************************************/
